#!/bin/bash

#
# locate any patch files in this directory and apply them
#

PATCH_FILES=$(find . -name '*.patch')

if [ -z "${PATCH_FILES}" ] ; then

	echo ""
	echo "There are no patches to apply..."
	echo ""
	exit 1

else
	
	for NEXT_PATCH in ${PATCH_FILES} ; do
	
		patch -p0 -i ${NEXT_PATCH}

	done

fi

# if they are new files they get created in the local directory ./ but we need to move these to ../
MOVE_FILES=$(find . -name '*.h' -o -name '*.c' -o -name '*.mt')

	for NEXT_MOVE in ${MOVE_FILES} ; do
	        echo "moving mv ${NEXT_MOVE} ../${NEXT_MOVE}"
		mv ${NEXT_MOVE} ../${NEXT_MOVE}

	done

exit 0
