#!/bin/bash

# create a file name for an archive to store patch source files in after we create their patch file
SOURCE_ARCHIVE="patch_sources.tar"
for my_path in "bfd" "gdb/config" "gdb" "include/elf" "include/opcode" "include" "opcodes"  ;
do
# echo "my path=${my_path}"

    # locate patch source files in this directory
    #'*.h' -o -name '*.c' -o -name '*.S' -o -name '*.in' -o -name '*.tgt' -o -name '*.bfd' -o -name 'configure')
    FILES_TO_PATCH=$(find ./${my_path} -name '*.h' -o -name '*.c' -o -name '*.S' -o -name '*.in' -o -name '*.tgt' -o -name '*.mt' -o -name '*.bfd' -o -name 'configure')




	# obtain the basename of this directory so we can exclude it in future searches
	CUR_DIR_BASE=$(basename $(pwd))

	for NEW_FILE in ${FILES_TO_PATCH} ; do
#        echo  "new file= ${NEW_FILE} "

		# obtain the basename of the file so we can use it in the next search
		FILE_NAME=$(basename ${NEW_FILE})
#		echo  "${FILE_NAME}"

		# locate the file that this will patch
#		OLD_FILE=$(find ../$my_path -wholename *${CUR_DIR_BASE}* -prune -o -name ${FILE_NAME} -print)

#		if [ -z "${OLD_FILE}" ] ; then
		OLD_FILE=../${my_path}/${FILE_NAME}
#                echo  "file does not exist ${OLD_FILE}"
#
#			echo ""
#			echo "ERROR - could not find old file to patch for file \"${FILE_NAME}\""
#			echo ""
#			exit 2
#
#		else


			echo "Creating patch for file \"${OLD_FILE}\""

			# make sure both files are unix format before diff'ing them
			dos2unix ${NEW_FILE} 2> /dev/null
			dos2unix ${OLD_FILE} 2> /dev/null

			# create the diff patch file
			diff -urN ${OLD_FILE} ${NEW_FILE} > ${NEW_FILE}.patch

			# archive the patch source file
			#tar --remove-files -rf ${SOURCE_ARCHIVE} ${NEW_FILE}
			tar  --remove-files -rf ${SOURCE_ARCHIVE} ${NEW_FILE}

#		fi

	done

 done

exit 0
